︠19f1766a-570d-4e67-be0c-d93e3b287480i︠
%md
# Cyclic sieving phenomenon

## Math 737 - Lab 9

︡8aac881c-2290-458e-828d-bec8d6058ec7︡{"done":true,"md":"# Cyclic sieving phenomenon\n\n## Math 737 - Lab 9"}
︠60346ffd-0e90-472d-b49f-ea231596d0bai︠
%md
### Let's look for cyclic sieving for rotation of bit strings (lists of zeros and ones)

#### First, let's look at the documentation for the CyclicSieving functions
︡a9e199e9-f1b2-4275-bb0a-a62f20ef0828︡{"done":true,"md":"### Let's look for cyclic sieving for rotation of bit strings (lists of zeros and ones)\n\n#### First, let's look at the documentation for the CyclicSieving functions"}
︠190b01fe-a6f2-4c63-b3fa-197c34204cdas︠
CyclicSievingCheck?
︡a9319dc0-95ae-4998-977e-6bf5d877e1d9︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /ext/sage/10.3/src/sage/misc/lazy_import.pyx\nDocstring :\nReturn whether the triple \"(L, cyc_act, f)\" exhibits the cyclic\nsieving phenomenon.\n\nIf \"cyc_act\" is None, \"L\" is expected to contain the orbit lengths.\n\nINPUT:\n\n* \"L\" -- if \"cyc_act\" is \"None\": list of orbit sizes, otherwise\n  list of objects\n\n* \"cyc_act\" -- (default:\"None\") bijective function from \"L\" to \"L\"\n\n* \"order\" -- (default:\"None\") if set to an integer, this\n     cyclic order of \"cyc_act\" is used (must be an integer multiple\n     of the order of \"cyc_act\") otherwise, the order of\n     \"cyc_action\" is used\n\nEXAMPLES:\n\n   sage: from sage.combinat.cyclic_sieving_phenomenon import *\n   sage: from sage.combinat.q_analogues import q_binomial\n   sage: S42 = Subsets([1,2,3,4], 2)\n   sage: def cyc_act(S): return Set(i.mod(4) + 1 for i in S)\n   sage: cyc_act([1,3])\n   {2, 4}\n   sage: cyc_act([1,4])\n   {1, 2}\n   sage: p = q_binomial(4,2); p\n   q^4 + q^3 + 2*q^2 + q + 1\n   sage: CyclicSievingPolynomial( S42, cyc_act )\n   q^3 + 2*q^2 + q + 2\n   sage: CyclicSievingCheck( S42, cyc_act, p )\n   True"}}︡{"done":true}
︠4c89d337-7d3f-4ecc-9b96-925e7f59d7c3s︠
CyclicSievingPolynomial?
︡06c46f20-9a28-4783-b530-bdf0322e79b1︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /ext/sage/10.3/src/sage/misc/lazy_import.pyx\nDocstring :\nReturn the unique polynomial \"p\" of degree smaller than \"order\"\nsuch that the triple \"(L, cyc_act, p)\" exhibits the Cyclic Sieving\nPhenomenon.\n\nIf \"cyc_act\" is None, \"L\" is expected to contain the orbit lengths.\n\nINPUT:\n\n* \"L\" -- if \"cyc_act\" is \"None\": list of orbit sizes, otherwise\n  list of objects\n\n* \"cyc_act\" -- (default:\"None\") bijective function from \"L\" to \"L\"\n\n* \"order\" -- (default:\"None\") if set to an integer, this\n     cyclic order of \"cyc_act\" is used (must be an integer multiple\n     of the order of \"cyc_act\") otherwise, the order of\n     \"cyc_action\" is used\n\n* \"get_order\" -- (default:\"False\") if \"True\", a tuple \"[p,n]\" is\n  returned where \"p\" is as above, and \"n\" is the order\n\nEXAMPLES:\n\n   sage: from sage.combinat.cyclic_sieving_phenomenon import CyclicSievingPolynomial\n   sage: S42 = Subsets([1,2,3,4], 2)\n   sage: def cyc_act(S): return Set(i.mod(4) + 1 for i in S)\n   sage: cyc_act([1,3])\n   {2, 4}\n   sage: cyc_act([1,4])\n   {1, 2}\n   sage: CyclicSievingPolynomial(S42, cyc_act)\n   q^3 + 2*q^2 + q + 2\n   sage: CyclicSievingPolynomial(S42, cyc_act, get_order=True)\n   [q^3 + 2*q^2 + q + 2, 4]\n   sage: CyclicSievingPolynomial(S42, cyc_act, order=8)\n   q^6 + 2*q^4 + q^2 + 2\n   sage: CyclicSievingPolynomial([4,2])\n   q^3 + 2*q^2 + q + 2"}}︡{"done":true}
︠6aff140e-b67a-4f1a-a181-678644af4dd2i︠
%md

#### Let's look at binary strings of length 4 with the action of rotation.

#### Run the commands below and figure out what each does.
︡54e04632-d54b-40c7-918d-652c0a8dd51c︡{"done":true,"md":"\n#### Let's look at binary strings of length 4 with the action of rotation. \n\n#### Run the commands below and figure out what each does."}
︠e6d3186b-2246-46f6-9a0b-a16d39a1cbb0︠
F = finite_dynamical_systems.bitstring_rotation(4, ones = 2)
list(F.ground_set())
F.evolution()((0,1,1,0)) #it rotates the system in one step
F.orbits()
F.orbit_lengths()
︡ec9c68f4-9863-41ec-be2c-cf077c73054a︡{"stdout":"[(1, 1, 0, 0), (1, 0, 1, 0), (1, 0, 0, 1), (0, 1, 1, 0), (0, 1, 0, 1), (0, 0, 1, 1)]\n"}︡{"stdout":"(1, 1, 0, 0)\n"}︡{"stdout":"[[(0, 0, 1, 1), (0, 1, 1, 0), (1, 1, 0, 0), (1, 0, 0, 1)], [(0, 1, 0, 1), (1, 0, 1, 0)]]\n"}︡{"stdout":"[4, 2]\n"}︡{"done":true}
︠042374ae-4f37-4ece-b19e-cee6b550e515i︠
%md

#### Run the commands below to see how to make q-analogue polynomials
︡30b10250-048f-4afd-8eee-fffa05e84353︡{"done":true,"md":"\n#### Run the commands below to see how to make q-analogue polynomials"}
︠0638d3c4-5a17-42b4-9274-37a7e9e7bcf9︠
from sage.combinat.q_analogues import *
q_int(4) #This command gives the q - analogue of 4
q_factorial(4) #This command gives the q - analogue of 4!
q_binomial(4,2) #This command gives the q - binomial of (4,2)
q_multinomial((2,2,2)) #This command gives the q - multinomial of ((2,2)).
︡6f710a97-2464-404c-a524-827debfac4ac︡{"stdout":"q^3 + q^2 + q + 1\n"}︡{"stdout":"q^6 + 3*q^5 + 5*q^4 + 6*q^3 + 5*q^2 + 3*q + 1\n"}︡{"stdout":"q^4 + q^3 + 2*q^2 + q + 1\n"}︡{"stdout":"q^12 + 2*q^11 + 5*q^10 + 7*q^9 + 11*q^8 + 12*q^7 + 14*q^6 + 12*q^5 + 11*q^4 + 7*q^3 + 5*q^2 + 2*q + 1\n"}︡{"done":true}
︠b66c7714-4fa1-45a9-b5b2-6ef792d45287i︠
%md

#### Now run the cyclic sieving functions below. What do they tell you?
︡6ee5e272-add6-4170-ac65-ae16f84740bf︡{"done":true,"md":"\n#### Now run the cyclic sieving functions below. What do they tell you?"}
︠06d2cd83-983b-4282-80ca-704114e782fas︠
R.<q> = PolynomialRing(QQ)
CyclicSievingCheck(F.orbit_lengths(),None,q_binomial(4,2)) # This command checks whether the tripple exhibits the cyclic sieving phenomenon.
CyclicSievingPolynomial(F.orbit_lengths())  #Return the unique polynomial "q" of degree smaller than "order" such that the triple from above exhibits the Cyclic Sieving Phenomenon.

︡378b75cd-1449-4cd4-8ec7-7827427fdbee︡{"stdout":"True\n"}︡{"stdout":"q^3 + 2*q^2 + q + 2\n"}︡{"done":true}
︠dd267ba8-167b-4035-b396-023db10943b0i︠
%md
## Exercise 1: Describe what you learned about how the above commands work. Be sure to describe what each command does.
︡ac26a011-4b4c-4eaa-9211-1218f7157a7a︡{"done":true,"md":"## Exercise 1: Describe what you learned about how the above commands work. Be sure to describe what each command does."}
︠f870bb77-0ced-4646-8c8b-5fbdcb7f3505︠

︡016a39ee-526a-4f48-8362-da1fbc01570d︡
︠4a344004-15c6-4c0c-9483-c912db714e37i︠
%md
## Exercise 2:
- ### Find two polynomials that exhibit cyclic sieving for length 8 binary strings with 4 ones under rotation: one polynomial by guessing a q-analogue and the other by using the function CyclicSievingPolynomial.
- ### How are these polynomials related?
- ### Guess what q-analogue polynomial exhibits cyclic sieving with length n binary strings with k ones under rotation.
︡d6f67d1a-24c0-4fcd-be46-40728a0bfb4d︡{"done":true,"md":"## Exercise 2: \n- ### Find two polynomials that exhibit cyclic sieving for length 8 binary strings with 4 ones under rotation: one polynomial by guessing a q-analogue and the other by using the function CyclicSievingPolynomial.\n- ### How are these polynomials related?\n- ### Guess what q-analogue polynomial exhibits cyclic sieving with length n binary strings with k ones under rotation."}
︠25eec84e-877e-41d2-8f91-bd4ac0ad6c7ai︠
%md
# <div style='text-align:center'> SOLUTION TO EXERCISE 2
︡d9de1462-ee8e-4fbd-89e8-336f111c3b42︡{"done":true,"md":"# <div style='text-align:center'> SOLUTION TO EXERCISE 2"}
︠6649c8df-5779-4480-917d-216fe600f67c︠

︡41dd7a8e-99c9-4f3e-ba07-80afe77c096c︡
︠26eddeac-225c-44ad-b65b-3a37ae9c1991i︠
%md
## Exercise 3: Print the polynomials that are the q-analogues of the Catalan numbers $\frac{1}{n+1}\binom{2n}{n}$, for $n=2,3,4,5$.
︡a36f5dc5-b4f5-4058-9f46-85730d8c2a6d︡{"done":true,"md":"## Exercise 3: Print the polynomials that are the q-analogues of the Catalan numbers $\\frac{1}{n+1}\\binom{2n}{n}$, for $n=2,3,4,5$."}
︠8b902ca0-eb1a-497d-a214-012aecd347a3︠

︡455ae93c-5578-44d4-b08f-d2feed7c94a9︡
︠8ca9290d-114a-492b-bd8d-909a57dfe57ci︠
%md
## Exercise 4: Verify that the set of standard Young tableaux of shape $(n,n)$ under promotion exhibits the CSP with the polynomial for Exercise 3 for $n=2,3,4,5$.

#### You can find this action by pressing tab in the block below.
︡50a063ef-5447-4c60-8c2c-d272e1b22069︡{"done":true,"md":"## Exercise 4: Verify that the set of standard Young tableaux of shape $(n,n)$ under promotion exhibits the CSP with the polynomial for Exercise 3 for $n=2,3,4,5$.\n\n#### You can find this action by pressing tab in the block below."}
︠6b5984c3-e588-453e-bca8-ba829480517f︠
finite_dynamical_systems.
︡8602ef98-0b67-460f-ab48-bccb5121097d︡
︠cdbfa175-26b1-40b7-a3f3-5cca42b1da6c︠
︡7861ae3e-8344-4b5c-8e9d-51c40ac21348︡
︠f43f736b-904e-447f-96fc-b7b223f35df3︠









